program Dir;
(***************************************************************
                 Simple TaskBar Application
                Copyright (c) 1999 . by TAL

         
       System Tray.   
    VCL      
   20  (D4 SP3).    
    DLL    .
 ***************************************************************)

uses
 Windows,
  Messages,
  Constant,
  TaskBar,
  shellapi;

{$R *.RES}
{$R TrayRes.RES}

const
  WM_TASKBAR = WM_APP + 1;  //   Tray Icon
  ICON_ID = 0;              //  
  Hint: array[0..63] of Char = '  '; // Hint

  sClassName = 'sTaskBarHandlerWindow';  //   

  AboutText = 'Directory Manager '#13 +
              'Copyright (c) 1999 . by Arick'#13+
              'aricksoft@mail.ru http:\\netlive.narod.ru';
  AboutCaption = 'About';
  AboutIcon = 'MAINICON';

var
  hWnd: THandle;
  WndClass: TWndClass;
  Msg: TMsg;
  TaskBarCreated: Integer;

Procedure ExeDirPath(i:integer);
var f:TextFile; g:integer;path:string;
begin
  path:=paramstr(0);//string
  CharUpperBuff(PChar(path),length(path));
  Delete(Path,Pos('DIR.EXE',Path),7);
  AssignFile(f,Path+'DirManager.txt');
  {$i-}
  g:=99;
  reset(f);
  if IORESULT=0 then
     begin
     while (EOF(F)=false)and(g<>i) do
     {$i+}
     begin
     g:=g+1;
     readln(f,path);
     end;
     if g=i then ShellExecute(hWnd,'open',PChar(path),nil,PChar(path),SW_SHOWNORMAL);
     end;
  closefile(f);
end;

Procedure AddPathToReg;
var path:string;i:integer;
f:textfile;
Begin
if paramcount=0 then exit;
path:=paramstr(0);
CharUpperBuff(PChar(path),length(path));
Delete(Path,Pos('DIR.EXE',Path),7);
AssignFile(f,Path+'DirManager.txt');
{$i-}
Append(f);
If IORESULT<>0 then rewrite(f);
{$i+}
Path:='';
For i:=1 to paramcount do
begin
if i=2 then path:=path+' ';
path:=path+paramstr(i);
end;
Writeln(f,Path);
CloseFile(f);
end;


procedure ShowAboutDialog;
//   MessageBoxIndirect,     
//   About     Windows 9x  NT
var
  Version: TOSVersionInfo;
  MsgBoxParamsW: TMsgBoxParamsW;
  MsgBoxParamsA: TMsgBoxParamsA;
begin
  Version.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  GetVersionEx(Version);
  if Version.dwPlatformId = VER_PLATFORM_WIN32_NT then begin
    FillChar(MsgBoxParamsW, SizeOf(MsgBoxParamsW), #0);
    with MsgBoxParamsW do begin
      cbSize := SizeOf(MsgBoxParamsW);
      hwndOwner := hWnd;
      hInstance := SysInit.hInstance;
      lpszText  := AboutText;
      lpszCaption := AboutCaption;
      lpszIcon := AboutIcon;
      dwStyle := MB_USERICON;
    end;
    MessageBoxIndirectW(MsgBoxParamsW);
  end else begin
    FillChar(MsgBoxParamsA, SizeOf(MsgBoxParamsA), #0);
    with MsgBoxParamsA do begin
      cbSize := SizeOf(MsgBoxParamsA);
      hwndOwner := hWnd;
      hInstance := SysInit.hInstance;
      lpszText  := AboutText;
      lpszCaption := AboutCaption;
      lpszIcon := AboutIcon;
      dwStyle := MB_USERICON;
    end;
    MessageBoxIndirectA(MsgBoxParamsA);
  end;
end;

procedure CreateTaskBarIcon;
begin
  TaskBarAddIcon(hWnd, ICON_ID, LoadIcon(hInstance, 'MAINICON'),
    WM_TASKBAR, Hint);
end;

procedure PopupMenu(hWnd: THandle);
var
  Menu: hMenu;
  Popup: hMenu; f:textfile;
  i:dword; path:string;
  P: TPoint; t:MENUITEMINFO;
begin
  Menu := LoadMenu(hInstance, 'MAINMENU');
  //    . .  TrayRes.RC
  Popup := GetSubMenu(Menu, 0);
  //Open file and Read
  i:=100;
  path:=paramstr(0);
  CharUpperBuff(PChar(path),length(path));
  Delete(Path,Pos('DIR.EXE',Path),7);
  AssignFile(f,Path+'DirManager.txt');
  {$i-}
  reset(f);
  If IORESULT=0 then
     begin
     {$i+}
     While EOF(f)=false do
       begin
       readln(f,path);
       FillChar(t,sizeof(MENUITEMINFO),0);
       with t do
            begin
            cbSize:=44;
            fType:=MFT_STRING;
            fMask:=MIIM_CHECKMARKS or MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
            wID := i;
            dwItemData:=i;
            dwTypeData:=PChar(path);
            cch:=Length(path);
            end;
       InsertMenuItem(popup, 0,false, t);
       i:=i+1;
       end;
     CloseFile(f);
     end;
  GetCursorPos(P);
  SetForegroundWindow(hWnd);
  TrackPopupMenu(Popup, TPM_CENTERALIGN or TPM_LEFTBUTTON,
    P.X, P.Y, 0, hWnd, NIL);
  PostMessage(hWnd, WM_NULL, 0, 0);
  DestroyMenu(Menu);
end;

function WindowProc(hWnd: THandle; uMsg, wParam, lParam: Integer): Integer;
  stdcall; export;
begin
  Result := 0;
  if uMsg = TaskBarCreated then
    //  Explorer.    System Tray 
    //  .
    CreateTaskbarIcon;
  case uMsg of
  //   
    WM_COMMAND:
      case wParam of
        ID_CLOSE: PostMessage(hWnd, WM_DESTROY, 0, 0);
        ID_ABOUT: ShowAboutDialog;
        100..900: ExeDirPath(wParam);
      end;
    //   
    WM_TASKBAR:
      case wParam of
        ICON_ID:
          case lParam of
           // WM_LBUTTONDBLCLK: ShowDLLForm(hWnd);
            WM_RBUTTONDOWN: PopupMenu(hWnd);
          end;
      end;
    //   Windows
    WM_DESTROY:
      begin
        PostQuitMessage(0);
        Exit;
      end;
  end;
  Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
end;

begin
  RegisterProg; //if prog ne registred then registred;
  addPathToReg;
  hWnd:=FindWindow(sClassName,nil);
  if hWnd=0 then begin

  AddToFile;
  FillChar(WndClass, SizeOf(WndClass), 0);
  with WndClass do begin
    hInstance      := SysInit.hInstance;
    lpszClassName  := sClassName;
    lpfnWndProc    := @WindowProc;
    //       
  end;
  RegisterClass(WndClass);
  hWnd := CreateWindow(sClassName, '', 0, 0, 0, 0, 0, 0, 0, hInstance, NIL);
  if hWnd = 0 then begin
    MessageBox(0, 'Initialisation failed', NIL, ID_OK);
    Exit;
  end;
  //     Explorer`
  TaskBarCreated := RegisterWindowMessage('TaskbarCreated');
  //  
  CreateTaskBarIcon;
  //  
  ShowWindow(hWnd, SW_HIDE);
  //   
  while GetMessage(Msg, 0, 0, 0) do begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
  end;
  //    
  TaskBarDeleteIcon(hWnd, ICON_ID);
  Halt(Msg.wParam);
  // .
  end
else halt(0);
end.


