unit TaskBar;

interface

uses Windows, ShellAPI;//sysutils;

const
  //    ShellAPI,      Uses
  // ,     
  NIF_TIP  = ShellAPI.NIF_TIP;
  NIF_ICON = ShellAPI.NIF_ICON;

function TaskBarAddIcon(
  hWindow: THandle;            // ,  
  ID: Cardinal;                //  
  ICON: hIcon;                 // 
  CallbackMessage: Cardinal;   // ,    
  Tip: PChar                   // ToolTip
): Boolean;

function TaskBarModifyIcon(
  hWindow: THandle;
  ID: Cardinal;
  Flags: Cardinal;
  ICON: hIcon;
  Tip: PChar): Boolean;

function TaskBarDeleteIcon(
 hWindow: THandle;
 ID: Integer): Boolean;

function RegisterProg:boolean;
procedure AddToFile;

implementation

function TaskBarAddIcon(
  hWindow: THandle;
  ID: Cardinal;
  ICON: hIcon;
  CallbackMessage: Cardinal;
  Tip: PChar): Boolean;
var
  NID: TNotifyIconData;
begin
  FillChar(NID, SizeOf(TNotifyIconData), 0);
  with NID do begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd   := hWindow;
    uID    := ID;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
    uCallbackMessage := CallbackMessage;
    hIcon  := Icon;
    lstrcpyn(szTip, Tip, SizeOf(szTip));
  end;
  Result := Shell_NotifyIcon(NIM_ADD, @NID);
end;

function TaskBarModifyIcon(
  hWindow: THandle;
  ID: Cardinal;
  Flags: Cardinal;
  ICON: hIcon;
  Tip: PChar): Boolean;
var
  NID: TNotifyIconData;
begin
  FillChar(NID, SizeOf(TNotifyIconData), 0);
  with NID do begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd    := hWindow;
    uID    := ID;
    uFlags := Flags;
    hIcon  := Icon;
    lstrcpyn(szTip, Tip, SizeOf(szTip));
  end;
  Result := Shell_NotifyIcon(NIM_MODIFY, @NID);
end;

function TaskBarDeleteIcon(
  hWindow: THandle;
  ID: Integer): Boolean;
var
  NID: TNotifyIconData;
begin
  FillChar(NID, SizeOf(TNotifyIconData), 0);
  with NID do begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd    := hWindow;
    uID    := ID;
  end;
  Result := Shell_NotifyIcon(NIM_DELETE, @NID);
end;

procedure RegisterProg;//:boolean;
var k:HKEY;
begin
if RegOpenKey(HKEY_CLASSES_ROOT,PChar('Folder\shell\Directory'),k)=ERROR_SUCCESS
then exit;
RegCreateKey (HKEY_CLASSES_ROOT,PChar('Folder\shell\Directory') ,k);
regsetvalue(k,nil,REG_SZ,pchar('Add directory'),sizeof(pchar('Add directory')));
RegCreateKey (k,PChar('command'),k);
RegSetValue(k,nil,REG_SZ,pchar(ParamStr(0)+' %1'),sizeof(pchar(ParamStr(0)+' %1')));
//RegCreateKey (HKEY_CLASSES_ROOT,PChar('Folder\shell\Directory\PathToDir'),k);
RegCloseKey(k);
end;

procedure AddToFile;
var f:TextFile;s:string; i:integer;
begin
{assignFile(f,ExtractFilePath(ParamStr(0))+'dir.txt');
append(f);    s:='';
for i:=1 to ParamCount do
s:=s+ParamStr(i)+' ';
writeln(f,s);
closeFile(f);  }
end;



end.
